/*@ 
theory uses Base {
  int: TYPE = Base.int;
  intArray: TYPE = Base.IntArray;
  smallestPosition: FORMULA
    FORALL(a: intArray, n: NAT, x: int):
      (EXISTS(i:int): 0 <= i AND i < n AND a.value[i] = x) =>
      (EXISTS(i:int): 0 <= i AND i < n AND a.value[i] = x AND
         (FORALL(j:int): 0 <= j AND j < n AND a.value[j] = x => j >= i));
}
@*/
public class Searching
{
  public static int search(int[] a, int x) /*@
    requires NOT (VAR a).null;
    ensures 
      LET result = VALUE@NEXT, n = (VAR a).length IN
      IF result = -1 THEN
        FORALL(i: INT): 0 <= i AND i < n => (VAR a).value[i] /= VAR x
      ELSE
         0 <= result AND result < n AND
         (FORALL(i: INT): 0 <= i AND i < result => 
           (VAR a).value[i] /= VAR x) AND
         (VAR a).value[result] = VAR x
      ENDIF;
  @*/
  {
    int n = a.length;
    int r = -1;
    int i = 0;
    while (i < n && r == -1) /*@
      invariant NOT (VAR a).null AND VAR n = (VAR a).length
            AND 0 <= VAR i AND VAR i <= VAR n
            AND (FORALL(i: INT): 0 <= i AND i < VAR i => 
                  (VAR a).value[i] /= VAR x)
            AND (VAR r = -1 OR (VAR r = VAR i AND VAR i < VAR n AND 
                   (VAR a).value[VAR r] = VAR x));
      decreases IF VAR r = -1 THEN VAR n - VAR i ELSE 0 ENDIF;  
    @*/
    {
      if (a[i] == x)
        r = i;
      else
        i = i+1;
    }
    return r;
  }
}








