public class Stack2 /*@
  invariant 
    NOT (VAR stack).null AND
    0 <= VAR n AND VAR n <= (VAR stack).length;
@*/
{
  private int[] stack;
  private int n;

  public Stack2() /*@
    assignable this;
    ensures VAR n = 0;
  @*/
  {
    stack = new int[10];
    n = 0;
  }

  public boolean isEmpty() /*@
    ensures VALUE@NEXT = TRUE <=> VAR n = 0;
  @*/
  {
    return n == 0;
  }

  public int top() /*@
    requires VAR n > 0;
    ensures  VALUE@NEXT = (VAR stack).value[VAR n-1];
  @*/
  {
    return stack[n-1];
  }

  public int pop() /*@
    requires VAR n > 0;
    assignable n;
    ensures VALUE@NEXT = (VAR stack).value[OLD n-1]
        AND VAR n = OLD n-1;
  @*/
  {
    int result = top();
    n = n-1;
    return result;
  }

  public void push(int v) /*@
    requires (VAR n = (VAR stack).length => 
               2*(VAR stack).length+1 <= Base.MAX_INT);
    assignable stack, n;
    ensures VAR n = OLD n+1
        AND (VAR stack).value[OLD n] = VAR v;
  @*/
  {
    if (n == stack.length) 
      stack = resize();  
    stack[n] = v;
    n = n+1;
  }

  private int[] resize() /*@
    helper;
    requires 
      NOT (VAR stack).null AND
      0 <= VAR n AND VAR n <= (VAR stack).length AND
      2*(VAR stack).length+1 <= Base.MAX_INT;
    ensures LET result = VALUE@NEXT IN
      NOT result.null AND 
      result.length > (OLD stack).length AND
      (FORALL(i: INT): 0 <= i AND i < VAR n =>
         result.value[i] = (OLD stack).value[i]);
  @*/
  {
    int[] stack0 = new int[2*stack.length+1];
    for (int i=0; i<n; i++) /*@
      invariant
        NOT (VAR stack).null AND
        0 <= VAR n AND VAR n <= (VAR stack).length AND
        0 <= VAR i AND VAR i <= VAR n AND
        NOT (VAR stack0).null AND
        (VAR stack0).length > (OLD stack).length AND
        (FORALL(i: INT): 0 <= i AND i < VAR i =>
           (VAR stack0).value[i] = (OLD stack).value[i]);
      decreases VAR n - VAR i;
    @*/
      stack0[i] = stack[i];
    return stack0;
  }
}







